(function ($) {
    "use strict";
    $.fn.greekify = function (options) {
        const settings = $.extend({
            onCharWritten: function () {
            }
        }, options);
        const z = {
            'A': 913, //&#913;
            'öA': 902,
            'a': 945,
            'öa': 940,
            'B': 914,
            'b': 946,
            'G': 915,
            'g': 947,
            'D': 916,
            'd': 948,
            'E': 917,
            'öE': 904,
            'e': 949,
            'öe': 941,
            'Y': 918,
            'y': 950,
            'H': 919,
            'öH': 905,
            'h': 951,
            'öh': 942,
            'U': 920,
            'u': 952,
            'I': 921,
            'öI': 906,
            'ÖI': 912,
            'i': 953,
            'öi': 943,
            'Öi': 970,
            'öl': 912,
            'K': 922,
            'k': 954,
            'L': 923,
            'l': 955,
            'M': 924,
            'm': 956,
            'N': 925,
            'n': 957,
            'J': 926,
            'j': 958,
            'O': 927,
            'öO': 908,
            'o': 959,
            'öo': 972,
            'P': 928,
            'p': 960,
            'R': 929,
            'r': 961,
            'S': 931,
            's': 963,
            'w': 962,
            'T': 932,
            't': 964,
            'Z': 933,
            'z': 965,
            'öz': 973,
            'ÖZ': 944,
            'Öz': 971,
            'F': 934,
            'f': 966,
            'X': 935,
            'x': 967,
            'C': 936,
            'c': 968,
            'V': 937,
            'öV': 911,
            'v': 969,
            'öv': 974,
            'q': 894

        };

        this.on("keyup", function () {
            if ($(this).val().charAt($(this).val().length - 1) !== ' ') {
                const entry = handleInput($(this).val());
                $(this).val(entry);
                // callback function
                settings.onCharWritten.call($(this));
            }
        });

        /**         
         * Since changes of characters are to be expected the whole string 
         * must be perused after each keyup event.
         * 
         * @param {String} input
         * @returns {String}
         */
        function handleInput(input) {

            /* //Bei Bedarf können Sie einen Button verwenden, um die Umwandlung zu deaktivieren
             if ($('button.transscription').hasClass('transscription-off')) {
                 return input;
             }
             * 
             */

            let output = "";
            let indexBuffer = "";
            for (let i = 0; i < input.length; i++) {
                indexBuffer += input.charAt(i);
                if (indexBuffer !== "Ö" && indexBuffer !== "ö") {
                    //pay attention to control characters and collect them
                    output += replace(indexBuffer);
                    indexBuffer = "";  //reset indexBuffer
                }
            }
            return   output + indexBuffer;
        }

        function replace(index) {
            if (z[index]) {  //number of unicode character is set:
                return String.fromCharCode(z[index]);
            }
            return index;  //no mapping defined, return the original input
        }
    };

}(jQuery));

